#ifndef _ANIMATION_H_
#define _ANIMATION_H_

#include "Surface.h"
#include "Graphics.h"
#include "Math.h"
#include <vector>

class Animation
{
public:
    Animation(int x, int y, int width, int height, int count, const Surface& sprite, float holdTime);
    void Update(float dt);
    void Draw(const Vector2Int& pos, Graphics& gfx);
    void Advance();
public:

private:
    std::vector<RectI> frames;
    float holdTime;
    float curFrameTime = 0.0f;
    int iCurFrame = 0;

private:
    const Surface& sprite;
};

#endif