#pragma once

#include "Keyboard.h"
#include "Mouse.h"
#include "Graphics.h"
#include "World.h"

class Game
{
public:
    Game(class MainWindow& wnd);
    Game(const Game&) = delete;
    Game& operator=(const Game&) = delete;
    void Initialize();
    void Render();
    void Update();
    void Destroy();
public:
    HWND* hWnd;
private:
    MainWindow& wnd;
    Graphics gfx;
    World world;
};