#include "Math.h"

Tile::Type Math::GetType(float height)
{
    if (height <= 0.2f)
        return Tile::Type::DeepWater;
    else if (height > 0.2f && height <= 0.3f)
        return Tile::Type::Water;
    else if (height > 0.3f && height <= 0.4f)
        return Tile::Type::Sand;
    else if (height > 0.4f && height <= 0.5f)
        return Tile::Type::Dirt;
    else if (height > 0.5f && height <= 0.6f)
        return Tile::Type::Pasture;
    else if (height > 0.6f && height <= 0.7f)
        return Tile::Type::Meadow;
    else if (height > 0.7f && height <= 0.8f)
        return Tile::Type::Prairie;
    else if (height > 0.8f && height <= 0.9f)
        return Tile::Type::GrassyTundra;
    else if (height > 0.9f)
        return Tile::Type::FrozenTundra;
    return Tile::Type();
}

std::string Math::GetTypeString(float height)
{
    if (height <= 0.2f)
        return "deepWater";
    else if (height > 0.2f && height <= 0.3f)
        return "water";
    else if (height > 0.3f && height <= 0.4f)
        return "sand";
    else if (height > 0.4f && height <= 0.5f)
        return "dirt";
    else if (height > 0.5f && height <= 0.6f)
        return "pasture";
    else if (height > 0.6f && height <= 0.7f)
        return "meadow";
    else if (height > 0.7f && height <= 0.8f)
        return "prairie";
    else if (height > 0.8f && height <= 0.9f)
        return "grassyTundra";
    else if (height > 0.9f)
        return "frozenTundra";
    return "null";
}