#ifndef _MATH_H_
#define _MATH_H_

#include "Tile.h"
#include "Constants.h"
#include <array>

class Math
{
public:

    // Clamps the given value between 1 greater than min and 1 less than max
    static int Clamp(int value, int max, int min)
    {
        if (value >= max)
            return max;
        if (value <= min)
            return min;

        return value;
    }

    static Vector2Int OrthoToIso(Vector2Int input)
    {
        Vector2Int original = input;

        input.x *= Constants::TileWidth;
        input.y *= Constants::TileHeight;

        original.x = (int)((input.y / Constants::TileHeight) + (input.x / Constants::TileWidth));
        original.y = (int)((input.x / Constants::TileWidth) - (input.y / Constants::TileHeight));

        return original;
    }

    static Tile::Type GetType(float height);

    static std::string GetTypeString(float height);
};

#endif