#include "PlayerCharacter.h"

void PlayerCharacter::Draw(Graphics & gfx)
{
    animations[(int)iCurState].Draw(position, gfx);
}

void PlayerCharacter::SetDirection(Vector2Int & dir)
{
    if (dir.x > 0.0f)
    {
        iCurState = State::WalkingRight;
        lastDir = dir;
    }
    else if (dir.x < 0.0f)
    {
        iCurState = State::WalkingLeft;
        lastDir = dir;
    }
    else if (dir.y < 0.0f)
    {
        iCurState = State::WalkingDown;
        lastDir = dir;
    }
    else if (dir.y > 0.0f)
    {
        iCurState = State::WalkingUp;
        lastDir = dir;
    }
    else
    {
        if (lastDir.x > 0.0f)
        {
            iCurState = State::IdleRight;
        }
        else if (lastDir.x < 0.0f)
        {
            iCurState = State::IdleLeft;
        }
        else if (lastDir.y < 0.0f)
        {
            iCurState = State::IdleDown;
        }
        else if (lastDir.y > 0.0f)
        {
            iCurState = State::IdleUp;
        }
    }

	velocity = dir * int( speed );
}

void PlayerCharacter::Update(float deltaTime)
{
	position += Vector2Int( 
		int( float( velocity.x ) * deltaTime ), 
		int( float( velocity.y ) * deltaTime ) 
	);
    animations[(int)iCurState].Update(deltaTime);
}