#include "Point.h"
#include <cmath>

Point::Point(int x, int y)
{
    this->x = x;
    this->y = y;
}

Point Point::operator+(const Point & rhs) const
{
    return Point(x + rhs.x, y + rhs.y);
}

Point & Point::operator+=(const Point & rhs)
{
    return *this = *this + rhs;
}

Point Point::operator*(int rhs) const
{
    return Point(x * rhs, y * rhs);
}

Point & Point::operator*=(int rhs)
{
    return *this = *this * rhs;
}

Point Point::operator-(const Point & rhs) const
{
    return Point(x - rhs.x, y - rhs.y);
}

Point & Point::operator-=(const Point & rhs)
{
    return *this = *this - rhs;
}

Point Point::operator/(int rhs) const
{
    return Point(x / rhs, y / rhs);
}

Point & Point::operator/=(int rhs)
{
    return *this = *this / rhs;
}

float Point::GetLength() const
{
    return std::sqrt(float(GetLengthSq()));
}

int Point::GetLengthSq() const
{
    return x * x + y * y;
}