#pragma once

#include "Vector2Int.h"

class RectI
{
public:
    RectI() = default;
    RectI(int left_in, int right_in, int top_in, int bottom_in);
    RectI(const Vector2Int& topLeft, const Vector2Int& bottomRight);
    RectI(const Vector2Int& topLeft, int width, int height);
    bool IsOverlappingWith(const RectI& other) const;
    bool IsContainedBy(const RectI& other) const;
    bool Contains(const Vector2Int& point) const;
    static RectI FromCenter(const Vector2Int& center, int halfWidth, int halfHeight);
    RectI GetExpanded(int offset) const;
    Vector2Int GetCenter() const;
    int GetWidth() const
    {
        return right - left;
    }
    int GetHeight() const
    {
        return bottom - top;
    }
public:
    int left;
    int right;
    int top;
    int bottom;
};