#include "Sprite.h"
#include "Constants.h"

Sprite::Sprite()
{
}

Sprite::Sprite(std::string filename, std::string name, int x, int y)
{
    this->name = name;
    Load(filename, name, x, y);
}

Sprite::Sprite(Surface surface, std::string name, int x, int y)
{
    this->name = name;
    Load(surface, name, x, y);
}

Sprite::~Sprite()
{
}

void Sprite::Load(std::string filename, std::string name, int x, int y)
{
    this->name = name;

    Surface surface = Surface(filename);

    color = new Color*[Constants::TileWidth];

    for (int w = 0; w < Constants::TileWidth; w++)
    {
        color[w] = new Color[Constants::TileHeight];

        for (int h = 0; h < Constants::TileHeight; h++)
        {
            color[w][h] = surface.GetPixel(x + w, y + h);
        }
    }
}

void Sprite::Load(Surface surface, std::string tileName, int x, int y)
{
    this->name = name;

    color = new Color*[Constants::TileWidth];

    for (int w = 0; w < Constants::TileWidth; w++)
    {
        color[w] = new Color[Constants::TileHeight];

        for (int h = 0; h < Constants::TileHeight; h++)
        {
            color[w][h] = surface.GetPixel(x + w, y + h);
        }
    }
}

Color ** Sprite::Get()
{
    return this->color;
}