#include "TileManager.h"
#include "Math.h"

TileManager::TileManager()
{
}

TileManager::~TileManager()
{
}

void TileManager::SetTile(int x, int y, Tile::Type type)
{
    tiles[x][y] = type;

    //SetTileBlend(x, y);
}

void TileManager::LoadSpriteSheet(std::string fileName, std::string spriteName, int collumns, int rows)
{
    int i = 0;

    Surface surface = Surface(fileName);

    for (int y = 0; y < collumns; y++)
    {
        for (int x = 0; x < rows; x++)
        {
            sprites[spriteName + std::to_string(i)] = (Sprite(surface, spriteName, x * Constants::TileWidth, y * Constants::TileHeight));
            i++;
        }
    }
}

void TileManager::SetTileBlend(int x, int y)
{
    std::array<Tile::Type, 8> neighbours = GetNeighbours(x, y);
}

std::array<Tile::Type, 8> TileManager::GetNeighbours(int c, int r)
{
    std::array<Tile::Type, 8> neighbours;

    const int y[] = { +1, +1, +0, -1, -1, -1, +0, +1 };
    const int x[] = { +0, +1, +1, +1, +0, -1, -1, -1 };

    for (int i = 0; i < 8; ++i)// visit the 8 spaces around it
        if (inField(r + y[i], c + x[i]))
            neighbours[i] = tiles[r + y[i]][c + x[i]];
        else
            neighbours[i] = Tile::Type::Void;

    return neighbours;
}

bool TileManager::inField(int r, int c)
{
    if (r < 0 || r >= 25) return false;
    if (c < 0 || c >= 25) return false;
    return true;
}

Color** TileManager::GetTile(int x, int y, float weight)
{
    std::string type = Math::GetTypeString(weight);
    std::string index = /*std::to_string(tiles_blendIndex[x][y]);*/ "0";
    return sprites[type + "_" + index].Get();
}

Color ** TileManager::GetTile(std::string tileName)
{
    return sprites[tileName].Get();
}