#ifndef _TILEMANAGER_H_
#define _TILEMANAGER_H_

#include <map>
#include <string>
#include <array>
#include "Sprite.h"
#include "Math.h"
#include "Constants.h"

class TileManager
{
public:
    TileManager();
    ~TileManager();
    void SetTile(int x, int y, Tile::Type type);
    void LoadSpriteSheet(std::string fileName, std::string spriteName, int collumns, int rows);
    Color** GetTile(int x, int y, float weight);
    Color** GetTile(std::string tileName);
public:
    std::array<std::array<Tile::Type, Constants::WorldWidth>, Constants::WorldHeight> tiles;
    std::map<std::string, Sprite> sprites;
private:
    void SetTileBlend(int x, int y);
    std::array<Tile::Type, 8> GetNeighbours(int x, int y);
    bool inField(int r, int c);
};

#endif