#include "World.h"
#include "Math.h"
#include "PerlinNoise.h"

#include "PlayerCharacter.h"

PlayerCharacter playerCharacter(Vector2Int(256, 256));

World::World()
{
}

void World::Initialize(Graphics & graphics)
{
    this->graphics = &graphics;

    // Load all sprites

    tileManager.LoadSpriteSheet("DeepWater.bmp", "deepWater_", 4, 12);
    tileManager.LoadSpriteSheet("Water.bmp", "water_", 4, 12);
    tileManager.LoadSpriteSheet("Dirt.bmp", "dirt_", 1, 1);
    tileManager.LoadSpriteSheet("Sand.bmp", "sand_", 4, 12);
    tileManager.LoadSpriteSheet("Meadow.bmp", "meadow_", 4, 12);
    tileManager.LoadSpriteSheet("Pasture.bmp", "pasture_", 4, 12);
    tileManager.LoadSpriteSheet("Prairie.bmp", "prairie_", 4, 12);
    tileManager.LoadSpriteSheet("GrassyTundra.bmp", "grassyTundra_", 4, 12);
    tileManager.LoadSpriteSheet("FrozenTundra.bmp", "frozenTundra_", 4, 12);
    tileManager.LoadSpriteSheet("Cursor.bmp", "Cursor", 1, 1);

    // Spawn player character

    //playerCharacter.Spawn(Constants::RenderWidth / 2, Constants::RenderHeight / 2);
    //cursorPosition = playerCharacter.GetAbsCoordinatesInChunk();

    PerlinNoise perlinNoise(Constants::Seed);

    for (unsigned int y = 0; y < Constants::RenderHeight; y++)
    {
        for (unsigned int x = 0; x < Constants::RenderWidth; x++)
        {
            double xx = (double)x / ((double)Constants::RenderWidth);
            double yy = (double)y / ((double)Constants::RenderHeight);

			heightmap[ x ][ y ] = float( perlinNoise.noise( xx, yy, 0.5 ) );
        }
    }

    for (unsigned char y = 0; y < Constants::RenderHeight; y++)
    {
        for (unsigned char x = 0; x < Constants::RenderWidth; x++)
        {
            Vector2Int coordinates = Math::OrthoToIso({ x, y });

            grid[x][y] = Point(coordinates.x * (Constants::TileWidth / 2),
                coordinates.y * (Constants::TileHeight / 2) + 300);
        }
    }

    StepFrame();
}

void World::StepFrame()
{
}

void World::Update(Keyboard& keyboard, Mouse& mouse)
{
    const bool dirUp = keyboard.KeyIsPressed(VK_UP);
    const bool dirDown = keyboard.KeyIsPressed(VK_DOWN);
    const bool dirLeft = keyboard.KeyIsPressed(VK_LEFT);
    const bool dirRight = keyboard.KeyIsPressed(VK_RIGHT);

    Vector2Int dir = { 0, 0 };
    if (dirUp)    dir.y = 1;
    if (dirDown)  dir.y = -1;
    if (dirRight) dir.x = 1;
    if (dirLeft)  dir.x = -1;

    playerCharacter.SetDirection(dir);
    playerCharacter.Update(ft.Mark());
}

void World::Render()
{
    //for (unsigned char y = 0; y < Constants::RenderHeight; y++)
    //{
    //    for (unsigned char x = 0; x < Constants::RenderWidth; x++)
    //    {
    //        Point point = grid[x][y];

    //        this->graphics->DrawSpriteColor
    //        (
    //            point.x,
    //            point.y,
    //            tileManager.GetTile
    //            (
    //                x + worldOffsetX,
    //                y + worldOffsetY,
    //                heightmap[x + worldOffsetX][y + worldOffsetY]
    //            )
    //        );
    //    }
    //}

    //Vector2Int mousePositionInGrid = Math::OrthoToIso(mousePosition);

    //this->graphics->DrawSpriteColor
    //(
    //    mousePositionInGrid.x,
    //    mousePositionInGrid.y,
    //    tileManager.GetTile
    //    (
    //        "Cursor0"
    //    )
    //);

    playerCharacter.Draw(*graphics);
}